open Bsmllib
open Zarith
open Bsmlutils

val replicate : 'a -> 'a par
val parfun : ('a -> 'b) -> 'a par -> 'b par
val parfun2 : ('a -> 'b -> 'c) -> 'a par -> 'b par -> 'c par
val parfun3 : ('a -> 'b -> 'c -> 'd) -> 'a par -> 'b par -> 'c par -> 'd par
val parfun4 :
  ('a -> 'b -> 'c -> 'd -> 'e) ->
  'a par -> 'b par -> 'c par -> 'd par -> 'e par
val apply2 : ('a -> 'b -> 'c) par -> 'a par -> 'b par -> 'c par
val apply3 :
  ('a -> 'b -> 'c -> 'd) par -> 'a par -> 'b par -> 'c par -> 'd par
val apply4 :
  ('a -> 'b -> 'c -> 'd -> 'e) par ->
  'a par -> 'b par -> 'c par -> 'd par -> 'e par
val none : 'a -> 'b option
val this : unit -> z par
val last : unit -> z
val within_bound : z -> bool
val hd : 'a list -> 'a
val tl : 'a list -> 'a list
val procs : unit -> z list
val pair_of_par : ('a, 'b) Tools.prod par -> ('a par, 'b par) Tools.prod
val par_of_pair : ('a par, 'b par) Tools.prod -> ('a, 'b) Tools.prod par
val mask : (z -> bool) -> 'a par -> 'a par -> 'a par
val noSome : 'a option -> 'a
val noSome_vect : 'a option par -> 'a par
val tl_hd_vect: 'a list par -> ('a, 'a list) Tools.prod par
val no_some_in_list_vect:  'a option list par -> 'a list par
val get_one : 'a par -> z par -> 'a par
val get_list: 'a par -> z list par -> 'a list par
val bsml_print: ('a -> unit) -> z -> 'a par -> unit par
val parprint: ('a -> unit) -> 'a par -> unit par
val inbounds : z -> z -> z -> bool
val mix : Zarith.z -> ('a par, 'a par) Tools.prod -> 'a par
