val bsp_p : unit -> Zarith.z

type 'a par = Par of 'a array

val array_init : Zarith.z -> (Zarith.z -> 'a) -> 'a array
val array_point : 'a array -> Zarith.z -> 'a
val mkpar : (Zarith.z -> 'a) -> 'a par
val apply : ('a -> 'b) par -> 'a par -> 'b par
val at : bool par -> Zarith.z -> bool
val put : (Zarith.z -> 'a option) par -> (Zarith.z -> 'a option) par
val super :
  (unit -> 'a par) -> (unit -> 'b par) -> ('a par, 'b par) Tools.prod
val bsp_FAIL: unit -> 'a
