type 'a list = Nil | Cons of 'a * 'a list

val zlength : 'a list -> Zarith.z
val znth : 'a list -> Zarith.z -> 'a
val app : 'a list -> 'a list -> 'a list
val map : ('a -> 'b) -> 'a list -> 'b list
val mklist : 'a -> 'a list
val id : 'a -> 'a
val compose : ('a -> 'b) -> ('c -> 'a) -> 'c -> 'b
val is_Some : 'a option -> bool

val from_to : Zarith.z -> Zarith.z list 
val from_to2 : Zarith.z -> Zarith.z list

val to_list : 'a list -> ('a -> 'b option) -> 'b list
val filtermap : 'a list -> ('a -> bool) -> ('a -> 'b) -> 'b list

val fold_left : ('a -> 'b -> 'a) -> ('b list) -> 'a -> 'a
